﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Data.OleDb;
using DxList.Properties;
using System.IO;

namespace DxList
{
    public partial class Form1 : Form
    {
        OleDbConnection conn = null;
        string mycall = "OK1DX";

        public class ctry_t
        {
            public string name;
            public int id;
            public bool valid;

            public override string ToString()
            {
                return name;
            }
        }

        public Form1()
        {
            InitializeComponent();
        }

        // import foxbase tabulky zemi
        private void ImportCountry(string filename)
        {
            OleDbConnection con = new OleDbConnection(@"Provider=VFPOLEDB.1;Data Source=" + filename);
            con.Open();
            OleDbCommand cmd = new OleDbCommand("select * from ctry",con );
            OleDbDataReader rdr = cmd.ExecuteReader();
            DataTable dt = new DataTable("ctry");
            dt.Load(rdr);

            cmd = new OleDbCommand();
            cmd.Connection = conn;
            cmd.CommandText = "delete from Ctry";
            cmd.ExecuteNonQuery();

            int idx = 1;
            foreach (DataRow dr in dt.Rows)
            {
                string pfx = dr["pfx"] as string;
                pfx = pfx.Trim();
                string ctry = dr["country"] as string;
                ctry = ctry.Trim();
                ctry = ctry.Replace('\'', '`');
                string cont = dr["cont"] as string;
                decimal waz = (decimal)dr["waz"];
                decimal itu = (decimal)dr["itu"];
                string valid = (bool)dr["valid"]?"1":"0";

                cmd.CommandText = "Insert into Ctry values ('" + pfx + "','" + ctry + "','" + cont + "'," + waz.ToString() + "," + itu.ToString() + "," + valid + "," + idx++.ToString() + ")";
                cmd.ExecuteNonQuery();
            }
        }

        // import tabulky QSO
        private void ImportQSO(string filename, string shortname)
        {
            OleDbConnection con = new OleDbConnection(@"Provider=VFPOLEDB.1;Data Source=" + filename);
            con.Open();
            OleDbCommand cmd = new OleDbCommand("select * from " + shortname, con);
            OleDbDataReader rdr = cmd.ExecuteReader();
            shortname = shortname.Substring(0, shortname.LastIndexOf('.'));
            DataTable dt = new DataTable(shortname);
            dt.Load(rdr);

            cmd = new OleDbCommand();
            cmd.Connection = conn;
            cmd.CommandText = "drop table "+shortname ;
            try
            {
                cmd.ExecuteNonQuery();
            }
            catch { };

            cmd.CommandText = "CREATE TABLE [" + shortname + "]([ctrynr] INTEGER,[call] TEXT(13),[bnd] INTEGER,[mode] TEXT(6)," +
                "[datum] DATETIME,[rst] TEXT(3),[cfm] YESNO)";
            cmd.ExecuteNonQuery();

            foreach (DataRow dr in dt.Rows)
            {
                decimal ctrynr = (decimal)dr["ctrynr"];
                string call = dr["call"] as string;
                call = call.Trim();

                decimal band = (decimal)dr["band"];
                 string mode = dr["mode"] as string;
                 mode = mode.Trim();
                DateTime date = (DateTime)dr["date"];
                string rst = dr["rst"] as string;
                rst = rst.Trim();
                string cfm = (bool)dr["cfm"] ? "1" : "0";

                cmd.CommandText = "Insert into "+shortname+" values (" + ctrynr.ToString() +",'" + call + "'," + band.ToString() + ",'" + mode + "','" + date.ToString() + "','" + rst + "'," + cfm + ")";
                cmd.ExecuteNonQuery();
            }

            mycall = shortname.Substring(0, shortname.Length - 2).ToUpper();  // bez _Q
            tbMyCall.Text = mycall;
            RekalkulaceTabulky();
        }

        private void butFajl_Click(object sender, EventArgs e)
        {
            OpenFileDialog dlg = new OpenFileDialog();
            dlg.Filter = "Foxpro databaze|*.dbf";
            if (dlg.ShowDialog() == DialogResult.OK)
            {
                tbFajl.Text = dlg.FileName;
                tbFajl.Tag = dlg.SafeFileName.ToUpper();
            }
        }

        private void butImport_Click(object sender, EventArgs e)
        {
            try
            {
                string sname = tbFajl.Tag as string;
                if ((sname == null) || (sname == ""))
                    return;

                if (sname == "CTRY.DBF")
                {
                    ImportCountry(tbFajl.Text);
                    MessageBox.Show("Import úspěšný");
                }
                else if (sname.LastIndexOf("_Q.DBF") > 0)
                {
                    ImportQSO(tbFajl.Text, sname);
                    MessageBox.Show("Import úspěšný");
                }
            }
            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Error");
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            try
            {
                mycall = Settings.Default.MyCall;
                conn = new OleDbConnection(@"Provider=Microsoft.Jet.OLEDB.4.0;Data Source=DxList.MDB"); //C:\Users\pvachal\HAM\DxWatcher\DxList\
                conn.Open();
                Width = Settings.Default.Width;
                Height = Settings.Default.Height;
            }
            catch
            {
                MessageBox.Show("Nezadařilo se otevřít databázi DxList.mdb", "Error");
                Close();
            }
        }

        // kdyz zadan prefix xeme, najde odpovidajici zaznam a naplni combo box moznymi zememi
        private void tbPfx_KeyPress(object sender, KeyPressEventArgs e)
        {
            ComboBox cb = null;
            TextBox tb = null;
            if (sender == tbPfx1)
            {
                cb = cbCtry1;
                tb = tbPfx1;
            }
            else if (sender == tbPfx6)
            {
                cb = cbCtry6;
                tb = tbPfx6;
            }
            else if (sender == tbPfx7)
            {
                cb = cbCtry7;
                tb = tbPfx7;
            }
            else
                return;
            if (e.KeyChar == (char)13)
            {
                OleDbCommand cmd = new OleDbCommand("select country,id,valid from Ctry where pfx = '" + tb.Text + "' order by valid", conn);
                OleDbDataReader rdr = cmd.ExecuteReader();
                DataTable tbl = new DataTable();
                tbl.Load(rdr);
                cb.Items.Clear();
                if (tbl.Rows.Count > 0)
                {
                    foreach (DataRow dr in tbl.Rows)
                    {
                        ctry_t ctry = new ctry_t();
                        ctry.name = dr["country"] as String;
                        ctry.id = (int)dr["id"];
                        ctry.valid = (bool)dr["valid"];
                        cb.Items.Add(ctry);
                    }
                }
                else
                {
                    cb.Items.Add("???");
                }
                cb.SelectedIndex = 0;
            }
        }


        // prepocita tabulku pro mycall
        void RekalkulaceTabulky()
        {
            OleDbCommand cmd = new OleDbCommand("select id,valid from Ctry", conn);
            OleDbDataReader rdr = cmd.ExecuteReader();
            DataTable tbl1 = new DataTable();
            tbl1.Load(rdr);

            cmd = new OleDbCommand("delete from Score where MyCall='" + mycall + "'", conn);
            cmd.ExecuteNonQuery();

            foreach (DataRow dr1 in tbl1.Rows)
            {
                int ctrynr = (int)dr1["id"];
                char valid = (bool)dr1["valid"]?'1':'0';

                cmd = new OleDbCommand("select bnd, mode from " + mycall + "_Q where ctrynr=" + ctrynr.ToString(),conn);
                rdr = cmd.ExecuteReader();
                DataTable tbl2 = new DataTable();
                tbl2.Load(rdr);

                char[] x = new char[15];
                for(int i=0;i<15;i++)
                    x[i] = '0';

                foreach (DataRow dr2 in tbl2.Rows)
                {
                    int bnd = (int)dr2["bnd"];
                    string mode = dr2["mode"] as string;
                    switch (bnd)
                    {
                        case 160:
                            x[0] = '1';
                            break;
                        case 80:
                            x[1] = '1';
                            break;
                        case 40:
                            x[2] = '1';
                            break;
                        case 30:
                            x[3] = '1';
                            break;
                        case 20:
                            x[4] = '1';
                            break;
                        case 17:
                            x[5] = '1';
                            break;
                        case 15:
                            x[6] = '1';
                            break;
                        case 12:
                            x[7] = '1';
                            break;
                        case 10:
                            x[8] = '1';
                            break;
                        case 6:
                            x[9] = '1';
                            break;
                        case 0: // satellite
                            x[10] = '1';
                            break;
                    }
                    switch (mode)
                    {
                        case "CW":
                            x[11] = '1';
                            break;
                        case "SSB":
                            x[12] = '1';
                            break;
                        case "RTTY":
                            x[13] = '1';
                            break;
                        case "SSTV":
                            x[14] = '1';
                            break;
                    }
                }

                cmd = new OleDbCommand("insert into score values ('"+mycall+"'," + ctrynr.ToString() + "," + x[0] + "," + x[1] + "," + x[2] + "," + x[3] + "," + x[4] + "," + x[5] + "," + x[6] + "," +
                     x[7] + "," + x[8] + "," + x[9] + "," + x[10] + "," + x[11] + "," + x[12] + "," + x[13] + "," + x[14] + "," +valid+ ")", conn);
                cmd.ExecuteNonQuery();
            }
            MessageBox.Show("Rekalkulace pro " + mycall + " hotová.");
        }

        private void butRecalc_Click(object sender, EventArgs e)
        {
            RekalkulaceTabulky();
        }

        private void cbCtry1_SelectedIndexChanged(object sender, EventArgs e)
        {
            ctry_t ctry = cbCtry1.SelectedItem as ctry_t;
            if (ctry != null)
            {
                lbValid1.Text = ctry.valid ? "Platná" : "Zrušená";
                OleDbCommand cmd = new OleDbCommand("select * from Score where MyCall='" + mycall + "' And ctrynr=" + ctry.id.ToString(), conn);
                OleDbDataReader rdr = cmd.ExecuteReader();
                DataTable tbl = new DataTable();
                tbl.Load(rdr);

                if (tbl.Rows.Count == 1)
                {
                    DataRow dr = tbl.Rows[0];
                    l160m.BackColor = (bool)dr["b160"] ? Color.Lime : Color.White;
                    l80m.BackColor = (bool)dr["b80"] ? Color.Lime : Color.White;
                    l40m.BackColor = (bool)dr["b40"] ? Color.Lime : Color.White;
                    l30m.BackColor = (bool)dr["b30"] ? Color.Lime : Color.White;
                    l20m.BackColor = (bool)dr["b20"] ? Color.Lime : Color.White;
                    l17m.BackColor = (bool)dr["b17"] ? Color.Lime : Color.White;
                    l15m.BackColor = (bool)dr["b15"] ? Color.Lime : Color.White;
                    l12m.BackColor = (bool)dr["b12"] ? Color.Lime : Color.White;
                    l10m.BackColor = (bool)dr["b10"] ? Color.Lime : Color.White;
                    l6m.BackColor = (bool)dr["b6"] ? Color.Lime : Color.White;
                    lsat.BackColor = (bool)dr["sat"] ? Color.Lime : Color.White;
                    lcw.BackColor = (bool)dr["cw"] ? Color.Lime : Color.White;
                    lssb.BackColor = (bool)dr["ssb"] ? Color.Lime : Color.White;
                    lrtty.BackColor = (bool)dr["rtty"] ? Color.Lime : Color.White;
                    lsstv.BackColor = (bool)dr["sstv"] ? Color.Lime : Color.White;
                }

                cmd = new OleDbCommand("select bnd,mode,call,datum,rst from " + mycall + "_Q where ctrynr=" + ctry.id.ToString() + " order by bnd, mode", conn);
                rdr = cmd.ExecuteReader();
                tbl = new DataTable();
                tbl.Load(rdr);
                dataGridView1.DataSource = tbl;
            }
            else
            {
                lbValid1.Text = "???";
                l160m.BackColor = BackColor;
                l80m.BackColor = BackColor;
                l40m.BackColor = BackColor;
                l30m.BackColor = BackColor;
                l20m.BackColor = BackColor;
                l17m.BackColor = BackColor;
                l15m.BackColor = BackColor;
                l12m.BackColor = BackColor;
                l10m.BackColor = BackColor;
                l6m.BackColor = BackColor;
                lsat.BackColor = BackColor;
                lcw.BackColor = BackColor;
                lssb.BackColor = BackColor;
                lrtty.BackColor = BackColor;
                lsstv.BackColor = BackColor;
                dataGridView1.DataSource = null;
            }
        }

        private void tabPage1_Enter(object sender, EventArgs e)
        {
            lbOwner.Text = mycall;
            int body = 0;

            int v,d;
            GetBandScore("b160",out v, out d);
            l160v.Text = v.ToString();
            body = v;
            l160d.Text = d.ToString();
            l160t.Text = ((int)(v + d)).ToString();
            GetBandScore("b80", out v, out d);
            l80v.Text = v.ToString();
            body += v;
            l80d.Text = d.ToString();
            l80t.Text = ((int)(v + d)).ToString();
            GetBandScore("b40", out v, out d);
            l40v.Text = v.ToString();
            body += v;
            l40d.Text = d.ToString();
            l40t.Text = ((int)(v + d)).ToString();
            GetBandScore("b30", out v, out d);
            l30v.Text = v.ToString();
            body += v;
            l30d.Text = d.ToString();
            l30t.Text = ((int)(v + d)).ToString();
            GetBandScore("b20", out v, out d);
            l20v.Text = v.ToString();
            body += v;
            l20d.Text = d.ToString();
            l20t.Text = ((int)(v + d)).ToString();
            GetBandScore("b17", out v, out d);
            l17v.Text = v.ToString();
            body += v;
            l17d.Text = d.ToString();
            l17t.Text = ((int)(v + d)).ToString();
            GetBandScore("b15", out v, out d);
            l15v.Text = v.ToString();
            body += v;
            l15d.Text = d.ToString();
            l15t.Text = ((int)(v + d)).ToString();
            GetBandScore("b12", out v, out d);
            l12v.Text = v.ToString();
            body += v;
            l12d.Text = d.ToString();
            l12t.Text = ((int)(v + d)).ToString();
            GetBandScore("b10", out v, out d);
            l10v.Text = v.ToString();
            body += v;
            l10d.Text = d.ToString();
            l10t.Text = ((int)(v + d)).ToString();
            GetBandScore("b6", out v, out d);
            l6v.Text = v.ToString();
            l6d.Text = d.ToString();
            l6t.Text = ((int)(v + d)).ToString();
            GetBandScore("sat", out v, out d);
            lsatv.Text = v.ToString();
            lsatd.Text = d.ToString();
            lsatt.Text = ((int)(v + d)).ToString();

            GetBandScore("cw", out v, out d);
            lcwv.Text = v.ToString();
            lcwd.Text = d.ToString();
            lcwt.Text = ((int)(v + d)).ToString();
            GetBandScore("ssb", out v, out d);
            lssbv.Text = v.ToString();
            lssbd.Text = d.ToString();
            lssbt.Text = ((int)(v + d)).ToString();
            GetBandScore("rtty", out v, out d);
            lrttyv.Text = v.ToString();
            lrttyd.Text = d.ToString();
            lrttyt.Text = ((int)(v + d)).ToString();
            GetBandScore("sstv", out v, out d);
            lsstvv.Text = v.ToString();
            lsstvd.Text = d.ToString();
            lsstvt.Text = ((int)(v + d)).ToString();
            GetBandScore("(cw or ssb or rtty or sstv)", out v, out d);
            lv.Text = v.ToString();
            ld.Text = d.ToString();
            lt.Text = ((int)(v + d)).ToString();
            lbody.Text = body.ToString();
        }

        private void GetBandScore(string band, out int valid, out int deleted)
        {
            valid = 0;
            deleted = 0;
            band += " and ";
            OleDbCommand cmd = new OleDbCommand("select count(*) from Score where " + band + "valid and MyCall='" + mycall +"'", conn);
            OleDbDataReader rdr = cmd.ExecuteReader();
            DataTable tbl = new DataTable();
            tbl.Load(rdr);
            if (tbl.Rows.Count == 1)
            {
                valid = (int)tbl.Rows[0][0];
            }
            cmd.CommandText = "select count(*) from Score where " + band + "not valid and MyCall='" + mycall +"'";
            rdr = cmd.ExecuteReader();
            tbl.Clear();
            tbl.Load(rdr);
            if (tbl.Rows.Count == 1)
            {
                deleted = (int)tbl.Rows[0][0];
            }
            return;
        }

        private void tabPage4_Enter(object sender, EventArgs e)
        {
            if (cbFiltr.SelectedIndex < 0)
                cbFiltr.SelectedIndex = 0;
            else
                cbFiltr_SelectedIndexChanged(null, null);
        }

        private void cbFiltr_SelectedIndexChanged(object sender, EventArgs e)
        {
            string filtr = "";
            switch (cbFiltr.SelectedIndex)
            {
                case 0:
                    filtr = "(cw or ssb or rtty or sstv)";
                    break;
                case 1:
                    filtr = "cw";
                        break;
                case 2:
                        filtr = "ssb";
                        break;
                case 3:
                        filtr = "rtty";
                        break;
                case 4:
                        filtr = "sstv";
                        break;
                case 5:
                        filtr = "b160";
                        break;
                case 6:
                        filtr = "b80";
                        break;
                case 7:
                        filtr = "b40";
                        break;
                case 8:
                        filtr = "b30";
                        break;
                case 9:
                        filtr = "b20";
                        break;
                case 10:
                        filtr = "b17";
                        break;
                case 11:
                        filtr = "b15";
                        break;
                case 12:
                        filtr = "b12";
                        break;
                case 13:
                        filtr = "b10";
                        break;
                case 14:
                        filtr = "b6";
                        break;
                case 15:
                        filtr = "sat";
                        break;
            }
            if (rbMiss.Checked)
                filtr = "not " + filtr;
            OleDbCommand cmd = new OleDbCommand("select pfx, country from Ctry, Score where id=ctrynr and " + filtr + " and MyCall='"+mycall+"' and score.valid order by pfx",conn);
            OleDbDataReader rdr = cmd.ExecuteReader();
            DataTable tbl = new DataTable();
            tbl.Load(rdr);
            dataGridView4.DataSource = tbl;
        }

        private void tbMyCall_KeyPress(object sender, KeyPressEventArgs e)
        {
            if (e.KeyChar == (char)13)
            {
                tbMyCall.Text = tbMyCall.Text.Trim().ToUpper();
                if (tbMyCall.Text == mycall)
                    return; //zadna zmena

                try
                {
                    OleDbCommand cmd = new OleDbCommand("select count(*) from " + tbMyCall.Text + "_Q", conn);
                    cmd.ExecuteReader();
                }
                catch
                {
                    if (MessageBox.Show("Volačka neznámá, vytvořit novou tabulku?", "Varování", MessageBoxButtons.YesNo) == DialogResult.Yes)
                    {
                        //ToDo vytvorit tabulku prazdnou, rekalkulovat
                        mycall = tbMyCall.Text;
                    }
                    return;
                }
                mycall = tbMyCall.Text;
            }
        }

        private void tabPage5_Enter(object sender, EventArgs e)
        {
            tbMyCall.Text = mycall;
            lbVerze.Text = "Verze " + Application.ProductVersion.ToString();
        }

        private void cbCtry6_SelectedIndexChanged(object sender, EventArgs e)
        {
            lMsg.Text = "";
            ctry_t ctry = cbCtry6.SelectedItem as ctry_t;
            if (ctry != null)
            {
                lbValid6.Text = ctry.valid ? "Platná" : "Zrušená";
            }
        }

        // zadani noveho QSO / zkontrolovat, ulozit do tabulky QSO a updatovat tabulku score
        private void butOK_Click(object sender, EventArgs e)
        {
            lMsg.Text = "";

            tbCall6.Text = tbCall6.Text.Trim().ToUpper();
            if (tbCall6.Text.Length < 2)
            {
                lMsg.Text = "Značka příliš krátká, neuloženo";
                return;
            }
            DateTime datum;
            try
            {
                datum = DateTime.Parse(tbDatum6.Text);
            }
            catch
            {
                lMsg.Text = "Chybné datum, neuloženo";
                return;
            }

            string band = "";
            int nband = -1;
            try
            {
                band = tbBand6.Text.Trim().ToLower();
                if ((band != "160") && (band != "80") && (band != "40") && (band != "30") && (band != "20") && (band != "17") && (band != "15") &&
                    (band != "12") && (band != "10") && (band != "6") && (band != "sat"))
                    throw new Exception();
                if (band == "sat")
                {
                    nband = 0;
                }
                else
                {
                    nband = int.Parse(band);
                    band = "b" + band;
                }
            }
            catch
            {
                lMsg.Text = "Neznámý band, neuloženo";
                return;
            }

            tbMode6.Text = tbMode6.Text.Trim().ToUpper();
            if ((tbMode6.Text != "CW") && (tbMode6.Text != "SSB") && (tbMode6.Text != "RTTY") && (tbMode6.Text != "SSTV"))
            {
                lMsg.Text = "Neznámý mode, neuloženo";
                return;
            }

            ctry_t ctry = cbCtry6.SelectedItem as ctry_t;
            if (ctry != null)
            {
                OleDbCommand cmd = new OleDbCommand("select * from Score where MyCall='" + mycall + "' and ctrynr=" +ctry.id.ToString(),conn);
                OleDbDataReader rdr = cmd.ExecuteReader();
                DataTable tbl = new DataTable();
                tbl.Load(rdr);
                if (tbl.Rows.Count > 0)
                {
                    DataRow dr = tbl.Rows[0];
                    bool existMode = ((bool)dr[tbMode6.Text.ToLower()]);
                    bool existBand = ((bool)dr[band]);
                    
                    if (existBand && existMode)
                    {
                        lMsg.Text ="Nepotvrzuje nic nového, neuloženo!";
                        return;
                    }

                    cmd = new OleDbCommand("insert into " + mycall + "_Q values(" + ctry.id.ToString() + ",'" + tbCall6.Text + "'," + nband.ToString() + ",'" +
                        tbMode6.Text + "','" + datum.ToShortDateString() + "','" + tbRst6.Text + "',0)", conn);
                    cmd.ExecuteNonQuery();

                    cmd = new OleDbCommand("update Score set " + band + "=1 , " + tbMode6.Text.ToLower() + "=1 where MyCall='" + mycall + "' and ctrynr=" + ctry.id.ToString(), conn);
                    cmd.ExecuteNonQuery();


                    if (!existBand && existMode)
                        lMsg.Text = "NOVÝ BAND!";
                    else if (existBand && !existMode)
                        lMsg.Text = "NOVÝ MODE!";
                    else
                        lMsg.Text = "NOVÝ BAND A NOVÝ MODE!";
                }

            }
        }

        private void Form1_FormClosed(object sender, FormClosedEventArgs e)
        {
            conn.Close();
            Settings.Default.Width = Width;
            Settings.Default.Height = Height;
            Settings.Default.MyCall = mycall;
            Settings.Default.Save();
        }

        private void tabPage2_Enter(object sender, EventArgs e)
        {
            cbCtry1_SelectedIndexChanged(null, null);

        }


        private void cbCtry7_SelectedIndexChanged(object sender, EventArgs e)
        {

            ctry_t ctry = cbCtry7.SelectedItem as ctry_t;
            if (ctry != null)
            {
                lbValid7.Text = ctry.valid ? "Platná" : "Zrušená";


                OleDbCommand cmd = new OleDbCommand("select MyCall,b160,b80,b40,b30,b20,b17,b15,b12,b10,b6,sat,cw,ssb,rtty,sstv from Score where ctrynr=" + ctry.id.ToString(), conn);
                OleDbDataReader rdr = cmd.ExecuteReader();
                DataTable tbl = new DataTable();
                tbl.Load(rdr);
                dataGridView7.DataSource = tbl;
            }
        }

        private void butExpCSV_Click(object sender, EventArgs e)
        {
            SaveFileDialog dlg = new SaveFileDialog();
            dlg.Filter = "log CSV format|*.csv";
            dlg.FileName = mycall;
            if ((dlg.ShowDialog() != DialogResult.OK) || (dlg.FileName.Length <= 0))
                return;

            try
            {
                TextWriter wr = new StreamWriter(dlg.FileName);

                OleDbCommand cmd = new OleDbCommand("select * from " + mycall + "_Q order by ctrynr", conn);
                OleDbDataReader rdr = cmd.ExecuteReader();
                DataTable tbl = new DataTable();
                tbl.Load(rdr);

                foreach (DataRow dr in tbl.Rows)
                {
                    string datum = ((DateTime)dr["datum"]).ToShortDateString();
                    string line = dr["ctrynr"] + "," + dr["call"] + "," + dr["bnd"] + "," + dr["mode"] + "," + datum + "," + dr["rst"] + "," + dr["cfm"];
                    wr.WriteLine(line);
                }
                wr.Close();
            }
            catch(Exception ex)
            {
                MessageBox.Show(ex.Message, "Export Failure");
            }
        }

        private void butImpCSV_Click(object sender, EventArgs e)
        {
            OpenFileDialog dlg = new OpenFileDialog();
            dlg.Filter = "log CSV format|*.csv";
            if (dlg.ShowDialog() != DialogResult.OK)
                return;

            TextReader rd = null;
            try
            {
                int pos1 = dlg.FileName.LastIndexOf('\\');
                int pos2 = dlg.FileName.LastIndexOf('.');
                if ((pos1 > 0) && (pos2 > pos1))
                {
                    string call = dlg.FileName.Substring(pos1 + 1, pos2 - pos1 - 1).ToUpper();
                    rd = new StreamReader(dlg.FileName);

                    OleDbCommand cmd = new OleDbCommand("drop table " + call + "_Q", conn);
                    try
                    {
                        cmd.ExecuteNonQuery();
                    }
                    catch { };
                    cmd.CommandText = "CREATE TABLE [" + call + "_Q]([ctrynr] INTEGER,[call] TEXT(13),[bnd] INTEGER,[mode] TEXT(6)," +
                        "[datum] DATETIME,[rst] TEXT(3),[cfm] YESNO)";
                    cmd.ExecuteNonQuery();

                    string line;
                    while ((line = rd.ReadLine()) != null)
                    {
                        string[] data = line.Split(new char[] { ',' });
                        if (data.GetLength(0) == 7)
                        {
                            cmd.CommandText = "insert into " + call + "_Q values (" + data[0] + ",'" + data[1] + "'," + data[2] + ",'" +
                                data[3] + "','" + data[4] + "','" + data[5] + "'," + data[6] + ")";
                            cmd.ExecuteNonQuery();
                        }
                    }
                    mycall = call;
                    tbMyCall.Text = call;
                    RekalkulaceTabulky();
                    MessageBox.Show("Data importována, tabulka rekalkulována");
                }
            }

            catch (Exception ex)
            {
                MessageBox.Show(ex.Message, "Import Failure");
            }
            rd.Close();
        }

        // clear the label text upon any change of text
        private void OnTxtChange(object sender, EventArgs e)
        {
            lMsg.Text = "";
        }

    }
}
